#include <ESP8266WiFi.h>
#include "Adafruit_MQTT.h"
#include "Adafruit_MQTT_Client.h"
#include "DHT.h"
/************************* WiFi Access Point *********************************/
#define WLAN_SSID "Jeff"
#define WLAN_PASS "1JMJ2311"
/************************* Adafruit.io Setup *********************************/
#define AIO_SERVER "io.adafruit.com"
#define AIO_SERVERPORT 1883 // use 8883 for SSL
#define AIO_USERNAME "Jeff_Mark"
#define AIO_KEY "aio_cLis527eJibjT8fdCqG5TxSSp0XA"

/************ Global State (you don't need to change this!) ******************/
// Create an ESP8266 WiFiClient class to connect to the MQTT server.
int t=0;
WiFiClient client;
// or... use WiFiFlientSecure for SSL
//WiFiClientSecure client;
// Setup the MQTT client class by passing in the WiFi client and MQTT server and login details.
Adafruit_MQTT_Client mqtt(&client, AIO_SERVER, AIO_SERVERPORT, AIO_USERNAME, AIO_KEY);
/****************************** Feeds ***************************************/
// Setup a feed called 'reading' for publishing.
// Notice MQTT paths for AIO follow the form: <username>/feeds/<feedname>

Adafruit_MQTT_Publish Number = Adafruit_MQTT_Publish(&mqtt, AIO_USERNAME "/feeds/temperature");

/*************************** Sketch Code ************************************/
// Bug workaround for Arduino 1.6.6, it seems to need a function declaration
// for some reason (only affects ESP8266, likely an arduino-builder bug).
void MQTT_connect();

const int relay1 = D2;// We will use the internal LED
const int relay2 = D8;

const int zero_1 = D4; // pin to check zero% from tank 1
const int hundred_1 = D5; //pin to check hundred% from tank 1

const int zero_2 = D1; //pin to check hundred% from tank 2
const int hundred_2 = D3; //pin to check hundred% from tank 2

const int zero_sump= D6;
const int hundred_sump= D7;

int empty_1, full_1, empty_2, full_2,empty_sump;
int a=0,b=0;


void setup() {
  Serial.begin(115200);

  delay(10);
  Serial.println(F("Adafruit MQTT demo"));
  // Connect to WiFi access point.
  Serial.println(); Serial.println();
  Serial.print("Connecting to ");
  Serial.println(WLAN_SSID);
  WiFi.begin(WLAN_SSID, WLAN_PASS);
  while (WiFi.status() != WL_CONNECTED) {
    delay(500);
    Serial.print(".");
  }
  Serial.println();
  Serial.println("WiFi connected");
  Serial.println("IP address: "); Serial.println(WiFi.localIP());
  
  pinMode(relay1,OUTPUT); // Set the LED Pin as an output
  pinMode(relay2,OUTPUT);
  pinMode(zero_1,INPUT_PULLUP);
  pinMode(hundred_1,INPUT_PULLUP);
  pinMode(zero_2,INPUT_PULLUP);
  pinMode(hundred_2,INPUT_PULLUP);// Set the contact sensor as an input
  pinMode(zero_sump,INPUT_PULLUP);
  pinMode(hundred_sump,INPUT_PULLUP);
}
uint32_t x=0;
Adafruit_MQTT_Subscribe *subscription;
void loop() {
  // Ensure the connection to the MQTT server is alive (this will make the first
  // connection and automatically reconnect when disconnected). See the MQTT_connect
  // function definition further below.
 
  MQTT_connect();

  empty_1 = digitalRead(zero_1);
  full_1 = digitalRead(hundred_1);
  empty_2 = digitalRead(zero_2);
  full_2 = digitalRead(hundred_2);// Take a reading
  empty_sump=digitalRead(zero_sump);
//---------------------------------------------------------------TANK1----------------------------------------------------------//
 if(empty_sump==LOW)
 {
  if(full_1 == HIGH && a==1) // since we are using pull up resistor when it is not in contact it will be HIGH
  {
    digitalWrite(relay1,HIGH);
    a=1;
  }
  else if(full_1==LOW)
  {
    digitalWrite(relay1,LOW);
    a=0;
  }
 
  else if(empty_1 == LOW && a==0)
  {
    digitalWrite(relay1,LOW);
    a=0;
  }
  else
  {
    digitalWrite(relay1,HIGH);
    a=1;
  }

 
//---------------------------------------------------------TANK2------------------------------------------------------------------------------//
   if(full_2 == HIGH && b==1) // since we are using pull up resistor when it is not in contact it will be HIGH
  {
    digitalWrite(relay2,HIGH);
    Serial.println("Tank is being filled\n Pump is ON");
    b=1;
  }
  else if(full_2==LOW)
  {
    digitalWrite(relay2,LOW);
    Serial.println("Tank is Full\n Pump is OFF");
    b=0;
  }
 
  else if(empty_2 == LOW && b==0)
  {
    digitalWrite(relay2,LOW);
    Serial.println("Tank has more than 30% water\n Pump is OFF");
    b=0;
  }
  else
  {
    digitalWrite(relay2,HIGH);
    Serial.println("Tank has less than 30% water\n Pump is ON");
    b=1;
  }
 }
 else
 {
  Serial.println("Sump Empty\n Pump switched OFF");
  digitalWrite(relay1,LOW);
  digitalWrite(relay2,LOW);
 }
  delay(5000);
}
// Function to connect and reconnect as necessary to the MQTT server.
// Should be called in the loop function and it will take care if connecting.
void MQTT_connect() {
  int8_t ret;
  // Stop if already connected.
  if (mqtt.connected()) {
    return;
  }
  Serial.print("Connecting to MQTT... ");
  uint8_t retries = 3;
  while ((ret = mqtt.connect()) != 0) { // connect will return 0 for connected
       Serial.println(mqtt.connectErrorString(ret));
       Serial.println("Retrying MQTT connection in 5 seconds...");
       mqtt.disconnect();
       delay(5000); // wait 5 seconds
       retries--;
       if (retries == 0) {
         // basically die and wait for WDT to reset me
         while (1);
       }
  }
  Serial.println("MQTT Connected!");
}
